#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include <iostream>
#include <cstdlib>
#include <vector>

// #define DBUS_API_SUBJECT_TO_CHANGE

#include <stdlib.h>
#include <dbus/dbus.h>
#include <dbus/dbus-glib.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <glib-object.h>

using namespace std;

static	GMainLoop *mainLoop=NULL;
static	DBusGConnection	*dBusG = NULL;
static	GError		*dError=NULL;
static	DBusGProxy	*dMgrObj=NULL;

static void run_mainLoop() {
	GMainContext *ctx;
	ctx=g_main_loop_get_context(mainLoop);
	while (g_main_context_pending(ctx))
		g_main_context_iteration(ctx, FALSE);
}

int main(int argc, char *argv[])
{
	char	*servicePath = (char *) malloc(32);

	g_type_init();
	g_log_set_always_fatal(G_LOG_LEVEL_WARNING);
	mainLoop=g_main_loop_new(NULL, FALSE);

	dBusG=dbus_g_bus_get(DBUS_BUS_SYSTEM, &dError);
	if (dError!=NULL) {
		cout << "Connection to System Bus failed: " << dError->message << endl;
		g_error_free(dError);
		return	EXIT_FAILURE;
	}

	run_mainLoop();

	dbus_g_connection_flush(dBusG);

//	registerMarshallers();

	dMgrObj=dbus_g_proxy_new_for_name(dBusG, "org.bluez", "/", "org.bluez.Manager");
	cout << "after dbus_g_proxy_new_for_name (dMgrObj)" << endl;
	cout << " bus:       " << dbus_g_proxy_get_bus_name(dMgrObj) << endl;
	cout << " path:      " << dbus_g_proxy_get_path(dMgrObj) << endl;
	cout << " interface: " << dbus_g_proxy_get_interface(dMgrObj) << endl;
	initManagerSignals(dBusG, dMgrObj);

/*
	Now, identify the Default Adapter path and establish a proxy to the org.bluez.Adapter interface for that Adapter
*/

	if (dbus_g_proxy_call(dMgrObj, "DefaultAdapter", &dError, G_TYPE_INVALID, G_TYPE_OBJECT, &servicePath, G_TYPE_INVALID)) {
		cout << "DefaultAdapter is " << servicePath << endl;
	} else {
		if (dError!=NULL) {
			cout << "Failed to get DefaultAdapter: " << dError->message << endl;
			g_error_free(dError);
			return	EXIT_FAILURE;
		}
	}
}